= How do I use the OWASP Zed Attack Proxy (ZAP) to scan the web application? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[https://www.owasp.org/index.php/OWASP_Zed_Attack_Proxy_Project OWASP Zed Attack Proxy (ZAP)] is a penetration testing tool used to identify vulnerabilities within web applications. It has the capability to work as a proxy server and run tests, including crawling the web application, fuzzing inputs, and actively attacking it. 

== Usage ==

The OWASP ZAP is a GUI based program and as SecureCI is run in headless mode, the default ZAP shell script cannot work as intended. 

Instead, designate that this is a command line execution via the –cmd parameter. The ZAP shell script is located within the extracted ZAP* directory and uses the following structure:

Execute the security scanning tool with this command line usage:
{{{

        zap.sh [-h |-help] [-newsession session_file_path | -session existing_session_file_path] [options] [-dir directory][[br]]
       		[-installdir directory] [-host host] [-port port] [-daemon] [-cmd] [-version]

}}}
[[br]]Command line options:
[[br]]  -cmd 					  Runs ZAP without opening the UI or calling the daemon. This is required when running in headless environments
[[br]]  -port 					Designates the port channel to send and receive requests. 
[[br]]  -quickurl [target url] 	Sets the target of the simple scan. An IP address or DNS host can be designated so long as it is routable. 
[[br]]  -quickout [filename] 	Generates a log of the scan. If the scan fails or the website cannot be reached, no log is created and no errors are returned as notification. In some cases, the only notification that the scan did not complete properly, aside from the lack of a log and report file, is the single line: Cannot listen on Port 8080. By default within SecureCI, this port is in use. 
[[br]]  -last_scan_report [path] Creates a report based on the previous scan of an existing session. 
[[br]]  -script [script_path] 	Script to run from commandline or load in GUI
[[br]][[br]]On a full operating system, not headless, the ZAP tool can be run from the GUI and customized in that manner. When attempting to run the default ZAP in a headless workstation, there will be errors if it is not designated to run in headless mode. 

=== More information ===

To run ZAP from the command line, or through Jenkins, and send the reports to a designated directory, use the sample script:

{{{
  JAVA_HOME=/usr/lib/jvm/default-java
  PATH=$JAVA_HOME/bin:$PATH
  ZAP_HOME=/opt/zap
  ZAP_OUTPUT=${ZAP_HOME}/ZAPScanResults
  TARGET_URL=https://${Target_IP_Address}/sonar

  $ZAP_HOME/zap.sh -cmd -port 9090 -newsession ${ZAP_OUTPUT}/scan${BUILD_NUMBER}.zap -quickout ${ZAP_OUTPUT}/scan${BUILD_NUMBER}.xml 
    -last_scan_report ${ZAP_OUTPUT}/scan${BUILD_NUMBER}.html -quickurl ${TARGET_URL}
}}} 

